//
//  UIView+PopDefineAlert.h
//  DefineAlert
//
//  Created by 攸 on 17/3/2.
//  Copyright © 2017年 com.jun. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <QuartzCore/QuartzCore.h>
@class PopDefineAlert;

@protocol defineAlertDelegate

- (void)buttonHaveTouchUpInside:(PopDefineAlert *)alert clickedButtonAtIndex:(NSInteger)buttonIndex TransCharacters:(NSMutableArray *)charArray charState:(BOOL)state;

@end

@interface PopDefineAlert : UIView<UITableViewDelegate,UITableViewDataSource,UIAlertViewDelegate,UITextFieldDelegate>{
    UIButton *currentBT;
    UIView *m_alertView;
    UIButton *longPress_button;
    BOOL switch_state;
}

// 提示视图
@property (nonatomic, strong) UIView *dialogView;
// 提示视图的子视图（自定义）
@property (nonatomic, strong) UIView *containerView;
// 按钮标题数组
@property (nonatomic, strong) NSArray *buttonTitles;
// 前后缀字符数组
@property (nonatomic, strong) NSMutableArray *characterText;
// 滚动控件
@property (nonatomic, strong) UIScrollView *scrollView;
// 按钮点击事件
@property (nonatomic, assign) id<defineAlertDelegate> delegate;
// 提示框标题
@property (nonatomic, strong) NSString *alertTitle;
// 前后缀字符列表
@property (nonatomic, strong) UIView *view;
@property (nonatomic, strong) UITableView *tableview;
@property (nonatomic, strong) NSMutableArray *Characters;
// 初始化
- (id)initWithTitle:(NSString *)title delegate:(id<defineAlertDelegate>)delegate charsArray:(NSMutableArray *)array switchState:(BOOL)state;
// 显示
- (void)show;
// 关闭
- (void)close;
// 设置子视图
- (void)setSubView: (UIView *)subView;
// 设置按钮点击事件
//- (void)setOnButtonTouchUpInside:(void (^)(PopDefineAlert *alertView, int buttonIndex))onButtonTouchUpInside;
// 设备旋转，横向/竖向改变
- (void)deviceOrientationDidChange: (NSNotification *)notification;

- (void)dealloc;

@end
