//
//  ViewController.m
//  TestMyFramework
//
//  Created by 攸 on 17/4/12.
//  Copyright © 2017年 com.jun. All rights reserved.
//

#import "ViewController.h"

// 设备屏幕宽度和高度
#define DEVICEWIDTH  (self.view.bounds.size.width)
#define DEVICEHEIGHT (self.view.bounds.size.height)
// 状态栏和导航栏的高度
#define NavHeight (self.navigationController.navigationBar.frame.size.height)
#define StatusHeight ([[UIApplication sharedApplication] statusBarFrame].size.height)

@interface ViewController ()<UIGestureRecognizerDelegate>{
    NSString *reciveData;       // 接收到的蓝牙数据
    UITextView *textview;       // 显示接收数据文本框
    UIButton *ScanAndConnect;   // 扫描并且连接蓝牙按钮
}

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // 创建界面UI
    [self createUI];
    
    // 初始化数据
    reciveData = @"";
    
    package = [[Package alloc] init];
    package.SDK_delegate = self;
}

- (void)createUI{
    self.view.backgroundColor = [UIColor clearColor];
    
    self.navigationItem.title = @"TestBLE";          // set item text
    
    UIImageView *bgview = [[UIImageView alloc]initWithFrame:self.view.bounds];
    bgview.image = [[UIImage imageNamed:@"ConnectBack.png"] stretchableImageWithLeftCapWidth:0 topCapHeight:0];
    
    UIImageView *image_logo = [[UIImageView alloc]initWithFrame:CGRectMake((DEVICEWIDTH-130)/2, StatusHeight+NavHeight, 130, 80)];
    image_logo.image = [UIImage imageNamed:@"CompanyLogo.png"];
    
    UILabel *lb_welcome = [[UILabel alloc]initWithFrame:CGRectMake((DEVICEWIDTH-300)/2, StatusHeight+NavHeight+70, 300, 20)];
    lb_welcome.text = @"Welcome to Unique BIM input method.";
    lb_welcome.font = [UIFont fontWithName:@"Arial" size:16];
    lb_welcome.textColor = [UIColor blueColor];
    lb_welcome.contentMode = UIControlContentVerticalAlignmentCenter;
    
    textview = [[UITextView alloc] initWithFrame:CGRectMake(5, StatusHeight+NavHeight+100, DEVICEWIDTH-10, DEVICEHEIGHT/4)];
    textview.text = @"The Keyboard test project!";
    textview.textColor = [UIColor greenColor];
    textview.backgroundColor = [UIColor grayColor];
    textview.editable = NO;
    
    UILabel *lb_CND = [[UILabel alloc]initWithFrame:CGRectMake(5, StatusHeight+NavHeight+DEVICEHEIGHT/4+120, DEVICEWIDTH, 20)];
    lb_CND.text = @"Step1⃣️:Scan and connect bluetooth.";
    lb_CND.font = [UIFont fontWithName:@"Arial" size:16];
    
    ScanAndConnect = [[UIButton alloc] initWithFrame:CGRectMake(5, StatusHeight+NavHeight+DEVICEHEIGHT/4+145, DEVICEWIDTH/2, 50)];
    [ScanAndConnect setTitle:@"Scan&Connect" forState:UIControlStateNormal];
    [ScanAndConnect setBackgroundImage:[UIImage imageNamed:@"ButtonBack.png"] forState:UIControlStateNormal];
    ScanAndConnect.titleLabel.font = [UIFont fontWithName:@"BanglaSangamMN-Bold" size:16];
    [ScanAndConnect addTarget:self action:@selector(scanAndConnect:) forControlEvents:UIControlEventTouchUpInside];
    
    UILabel *lb_test = [[UILabel alloc]initWithFrame:CGRectMake(5, StatusHeight+NavHeight+DEVICEHEIGHT/4+210, DEVICEWIDTH, 20)];
    lb_test.text =@"Step2️⃣:Scan and connect bluetooth.";
    lb_test.font = [UIFont fontWithName:@"Arial" size:16];
    
    UIButton *FunctionBT = [[UIButton alloc] initWithFrame:CGRectMake(5, StatusHeight+NavHeight+DEVICEHEIGHT/4+235, DEVICEWIDTH/2, 50)];
    [FunctionBT setTitle:@"Set&Functions" forState:UIControlStateNormal];
    [FunctionBT setBackgroundImage:[UIImage imageNamed:@"ButtonBack.png"] forState:UIControlStateNormal];
    FunctionBT.titleLabel.font = [UIFont fontWithName:@"BanglaSangamMN-Bold" size:16];
    [FunctionBT addTarget:self action:@selector(functionMehtod:) forControlEvents:UIControlEventTouchUpInside];
    
    UILabel *lb_recon = [[UILabel alloc]initWithFrame:CGRectMake(5, StatusHeight+NavHeight+DEVICEHEIGHT/4+290, DEVICEWIDTH, 20)];
    lb_recon.text =@"Step3️⃣:Reconnect the bluetooth device.";
    lb_recon.font = [UIFont fontWithName:@"Arial" size:16];
    
    UIButton *bt_recon = [[UIButton alloc] initWithFrame:CGRectMake(5, StatusHeight+NavHeight+DEVICEHEIGHT/4+315, DEVICEWIDTH/2, 50)];
    [bt_recon setTitle:@"Reconnect" forState:UIControlStateNormal];
    [bt_recon setBackgroundImage:[UIImage imageNamed:@"ButtonBack.png"] forState:UIControlStateNormal];
    bt_recon.titleLabel.font = [UIFont fontWithName:@"BanglaSangamMN-Bold" size:16];
    [bt_recon addTarget:self action:@selector(reconnectMehtod:) forControlEvents:UIControlEventTouchUpInside];
    
    [self.view addSubview:bgview];
    [self.view addSubview:image_logo];
    [self.view addSubview:lb_welcome];
    [self.view addSubview:textview];
    [self.view addSubview:lb_CND];
    [self.view addSubview:ScanAndConnect];
    [self.view addSubview:lb_test];
    [self.view addSubview:FunctionBT];
    [self.view addSubview:lb_recon];
    [self.view addSubview:bt_recon];
}

// 扫面并连接按钮按下时的响应事件
- (void)scanAndConnect:(UIButton *)button{
    
    if ([ScanAndConnect.titleLabel.text isEqualToString:@"Scan&Connect"]) {
        [package popUpBluetoothDialog];
    }else{
        textview.text =reciveData = @"";
        [package disconnect];
        // 断开连接后设置连接按钮的文字
        [ScanAndConnect setTitle:@"Scan&Connect" forState:UIControlStateNormal];
    }
}

// 功能按钮按下时的事件响应
- (void)functionMehtod:(UIButton *)button{
    [package setDeviceFunction:self.view];
}


- (void)reconnectMehtod:(UIButton *)button{
    if ([ScanAndConnect.titleLabel.text isEqualToString:@"Scan&Connect"])
        [package reconnectDevice];
    else
        NSLog(@"You cann't reconnect the device,It's already connected!\n");
}

#pragma _mark SDK_delegate method
// 接收蓝牙数据
- (void)RecivedData:(NSString *)data{
    if (data != nil && ![data isEqualToString:@""]) {
        reciveData = [reciveData stringByAppendingString:data];
        textview.text = reciveData;
    }else{
        textview.text = @"Recived Data is null!";
    }
}
// 连接蓝牙成功
- (void)ConnectBLESuccess:(BOOL)isConnect{
    if (isConnect) {
        [ScanAndConnect setTitle:@"DEVConnected" forState:UIControlStateNormal];
        NSLog(@"Connect BLE had successed!\n");
    }
}
// 连接蓝牙失败
- (void)ConnectBLEFailed:(BOOL)connectFial{
    if (connectFial) {
        NSLog(@"Connect BLE had failed!\n");
    }
}
// 断开蓝牙连接
- (void)DisconnectedBLE:(BOOL)disconnect{
    if (disconnect) {
        [ScanAndConnect setTitle:@"Scan&Connect" forState:UIControlStateNormal];
        NSLog(@"Device had disconnected!\n");
    }
    
}

-(void)ReConnectBLEDevice:(BOOL)reconnect{
    if (!reconnect) {
        NSLog(@"Reconnect device failed!\n");
    }
}

@end
