//
//  BLETableAlert.h
//  BIMInput
//
//  Created by 攸 on 16/12/5.
//  Copyright © 2016年 com.jun. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <QuartzCore/QuartzCore.h>

@class BLETableAlert;

// Blocks definition for table view management
typedef NSInteger (^BLETableAlertNumberOfRowsBlock)(NSInteger section);
typedef UITableViewCell* (^BLETableAlertTableCellsBlock)(BLETableAlert *alert, NSIndexPath *indexPath);
typedef void (^BLETableAlertRowSelectionBlock)(NSIndexPath *selectedIndex);
typedef void (^BLETableAlertCompletionBlock)(void);

@interface BLETableAlert : UIView <UITableViewDataSource, UITableViewDelegate>

@property (nonatomic, strong) UITableView *table;
@property (nonatomic, assign) CGFloat height;
@property (nonatomic, strong) BLETableAlertCompletionBlock completionBlock;     // Called when Cancel button pressed
@property (nonatomic, strong) BLETableAlertRowSelectionBlock selectionBlock;	// Called when a row in table view is pressed

// Classe method; rowsBlock and cellsBlock MUST NOT be nil
+(BLETableAlert *)tableAlertWithTitle:(NSString *)title cancelButtonTitle:(NSString *)cancelBtnTitle numberOfRows:(BLETableAlertNumberOfRowsBlock)rowsBlock andCells:(BLETableAlertTableCellsBlock)cellsBlock;

// Initialization method; rowsBlock and cellsBlock MUST NOT be nil
-(id)initWithTitle:(NSString *)title cancelButtonTitle:(NSString *)cancelBtnTitle numberOfRows:(BLETableAlertNumberOfRowsBlock)rowsBlock andCells:(BLETableAlertTableCellsBlock)cellsBlock;

// Allows you to perform custom actions when a row is selected or the cancel button is pressed
-(void)configureSelectionBlock:(BLETableAlertRowSelectionBlock)selBlock andCompletionBlock:(BLETableAlertCompletionBlock)comBlock;

// Show the alert
-(void)show;

@end
