//
//  NSObject+Package.h
//  UniqueInput
//
//  Created by 攸 on 17/2/9.
//  Copyright © 2017年 com.jun. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "BLEManager.h"
#import "BLETableAlert.h"
#import "SGPopSelectView.h"
#import "PopDefineAlert.h"

@protocol PackageDelegate <NSObject>

@required
- (void)RecivedData :(NSString *)data;
- (void)ConnectBLESuccess : (BOOL)isConnect;
- (void)ConnectBLEFailed : (BOOL)connectFail;
- (void)DisconnectedBLE : (BOOL)disconnect;
- (void)ReConnectBLEDevice: (BOOL)reconnect;

@end


@interface Package : NSObject<UIGestureRecognizerDelegate,UIAlertViewDelegate,defineAlertDelegate,BLEManagerDelegate>
{
    BLEmanager *bleManager;
    
    SGPopSelectView *popView;
    
    NSTimer *timer;
    
    UIView *myView;
    
    NSUInteger StringCode;
    
    NSTimer *m_Timer;
}

@property(strong,nonatomic)NSArray *selections;
@property(strong,nonatomic)BLEmanager *bleManager;
@property(strong,nonatomic)SGPopSelectView *popView;
@property(strong, nonatomic)BLETableAlert  *bleAlert;
@property(weak, nonatomic) id<PackageDelegate> SDK_delegate;

- (void)popUpBluetoothDialog;

- (void)writeData:(NSData *)data;

- (void)disconnect;

- (void)setDeviceFunction:(UIView *)view;

- (void)reconnectDevice;

@end
